%define major 0
%define libbase %mklibname %{name}-base %{major}
%define libclient %mklibname %{name}-client %{major}
%define libserver %mklibname %{name}-server %{major}
%define mainver %(echo %{version} | sed -e "s/\\([0-9]*\\.[0-9]*\\).[0-9]*/\\1/")

Summary:	Extremely fast and flexible web server
Name:		cherokee
Version:	1.2.103
%define subrel 1
Release:	%mkrel 17
License:	GPLv2
Group:		System/Servers
Source0:	https://github.com/cherokee/webserver/archive/v%{version}.tar.gz
Source1:	cherokee.init
Source2:	cherokee.logrotate
Source3:	cherokee.service
# SOURCE4 from https://github.com/cherokee/CTK/archive/master.tar.gz
Source4:	CTK.tar.gz
Patch0:		cherokee-1.2.101-link.patch
Patch1:		cherokee-1.2.103_CVE-2014-4668.patch
Patch2:		cherokee-1.2.103-openssl1.1.patch
Patch3:		cherokee-1.2.103-CVE-2019-16892.patch
URL:		http://www.cherokee-project.com/
BuildRequires:	ffmpeg-devel
BuildRequires:	php-devel
BuildRequires:	php-cgi
BuildRequires:	mysql-devel
BuildRequires:	openldap-devel
BuildRequires:	pkgconfig(openssl)
BuildRequires:	pkgconfig(geoip)
BuildRequires:	wget
Recommends:	rrdtool
Requires:	php-cgi
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1
Provides:	webserver

%description
Cherokee is an extremely flexible and fast web server. It's embedable,
extensible with plug-ins. It has handler-to-path, virtual servers, gzip
encoding, modular loggers, CGI support, and can run in a chroot
environment, among other features.

%files -f %{name}.lang
%{_initrddir}/%{name}
/lib/systemd/system/%{name}.service
%dir %{_sysconfdir}/cherokee
%config(noreplace) %{_sysconfdir}/cherokee/cherokee.conf
%{_sysconfdir}/cherokee/cherokee.conf.perf_sample
%config(noreplace) %{_sysconfdir}/pam.d/%{name}
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{_bindir}/cherokee-admin-launcher
%{_bindir}/cherokee-macos-askpass
%{_bindir}/cherokee-panic
%{_bindir}/cherokee-tweak
%{_bindir}/CTK-run
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/*.so
%{_sbindir}/*
%{_datadir}/%{name}
%doc %{_datadir}/doc/%{name}
%{_mandir}/man1/cherokee-admin.*
%{_mandir}/man1/cherokee-admin-launcher.*
%{_mandir}/man1/cherokee-tweak.*
%{_mandir}/man1/cherokee-worker.*
%{_mandir}/man1/cherokee.*
%{_var}/www/images/cherokee-logo.png
%{_var}/www/images/default-bg.png
%{_var}/www/images/favicon.ico
%{_var}/www/images/powered_by_cherokee.png
%{_var}/www/index.html

#----------------------------------------------------------------------

%package -n	cget
Group:		System/Servers
Summary:	Web page downloader

%description -n	cget
CGet is a small downloader based in the Cherokee client library.

%files -n cget
%{_bindir}/cget
%{_mandir}/man1/cget.*

#----------------------------------------------------------------------

%package -n	%{libbase}
Group:		System/Servers
Summary:	Extremely fast and flexible web server - libraries

%description -n	%{libbase}
Cherokee is an extremely flexible and fast web server. It's embedable,
extensible with plug-ins. It has handler-to-path, virtual servers, gzip
encoding, modular loggers, CGI support, and can run in a chroot
environment, among other features.

This is the runtime library.

%files -n %{libbase}
%{_libdir}/libcherokee-base.so.%{major}{,.*}

#----------------------------------------------------------------------

%package -n	%{libclient}
Group:		System/Servers
Summary:	Extremely fast and flexible web server - libraries

%description -n	%{libclient}
Cherokee is an extremely flexible and fast web server. It's embedable,
extensible with plug-ins. It has handler-to-path, virtual servers, gzip
encoding, modular loggers, CGI support, and can run in a chroot
environment, among other features.

This is the client runtime library.

%files -n %{libclient}
%{_libdir}/libcherokee-client.so.%{major}{,.*}

#----------------------------------------------------------------------

%package -n	%{libserver}
Group:		System/Servers
Summary:	Extremely fast and flexible web server - libraries

%description -n	%{libserver}
Cherokee is an extremely flexible and fast web server. It's embedable,
extensible with plug-ins. It has handler-to-path, virtual servers, gzip
encoding, modular loggers, CGI support, and can run in a chroot
environment, among other features.

This is the server runtime library.

%files -n %{libserver}
%{_libdir}/libcherokee-server.so.%{major}{,.*}

#----------------------------------------------------------------------

%package	devel
Group:		System/Servers
Requires:	%{libbase} = %{version}
Requires:	%{libclient} = %{version}
Requires:	%{libserver} = %{version}
Summary:	Extremely fast and flexible web server - development files

%description	devel
Cherokee is an extremely flexible and fast web server. It's embedable,
extensible with plug-ins. It has handler-to-path, virtual servers, gzip
encoding, modular loggers, CGI support, and can run in a chroot
environment, among other features.

This package contains the server development files - headers, .so and .a files.

%files devel
%{_bindir}/%{name}-config
%{_libdir}/*.so
%{_includedir}/%{name}
%{_libdir}/pkgconfig/*.pc
%{_datadir}/aclocal/*.m4
%{_mandir}/man1/%{name}-config.*

#----------------------------------------------------------------------
%prep
%setup -q -n webserver-%{version} -a4
%patch0 -p0
%patch1 -p1 -b .CVE-2014-4668
%patch2 -p1
%patch3 -p1 -b .CVE-2019-16892
mv CTK-master/* admin/CTK

%build
%serverbuild
NO_CONFIGURE=yes ./autogen.sh
%configure2_5x --disable-static --enable-os-string="%{distribution} %{distro_release} for %{product_arch}"
%make_build

%install
%make_install

%find_lang %{name}

find %{buildroot} -name *.la -delete

%{__install} -D -m 0644 pam.d_cherokee %{buildroot}%{_sysconfdir}/pam.d/%{name}
%{__install} -D -m 0755 %{SOURCE1} %{buildroot}%{_initrddir}/%{name}
%{__install} -D -m 0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
%{__install} -D -m 0644 %{SOURCE3} %{buildroot}/lib/systemd/system/%{name}.service

%{buildroot}%{_datadir}/%{name}/admin/upgrade_config.py %{buildroot}%{_sysconfdir}/%{name}/%{name}.conf
rm -f %{buildroot}%{_sysconfdir}/%{name}/%{name}.conf.backup

%post
[[ -e %{_sysconfdir}/%{name}/%{name}.conf ]] && %{_datadir}/%{name}/admin/upgrade_config.py %{_sysconfdir}/%{name}/%{name}.conf


%changelog
* Tue Dec 29 2020 ns80 <ns80> 1.2.103-17.1.mga7
+ Revision: 1664747
- backport upstream patch for CVE-2019-16892 (mga#27736)

* Sat Sep 22 2018 umeabot <umeabot> 1.2.103-17.mga7
+ Revision: 1296117
- Mageia 7 Mass Rebuild

* Thu Apr 26 2018 daviddavid <daviddavid> 1.2.103-16.mga7
+ Revision: 1222553
- rebuild for new ffmpeg 4.0

* Sat Dec 23 2017 wally <wally> 1.2.103-15.mga7
+ Revision: 1184224
- rebuild for new mariadb

* Mon Sep 18 2017 guillomovitch <guillomovitch> 1.2.103-14.mga7
+ Revision: 1155207
- fix build with openssl 1.1

* Tue May 02 2017 akien <akien> 1.2.103-13.mga6
+ Revision: 1098272
- Rebuild for ffmpeg 3.3

* Wed Mar 08 2017 akien <akien> 1.2.103-12.mga6
+ Revision: 1089843
- Rebuild for ffmpeg 3.2.4

* Wed Mar 02 2016 umeabot <umeabot> 1.2.103-11.mga6
+ Revision: 983335
- Rebuild for openssl

* Tue Feb 09 2016 umeabot <umeabot> 1.2.103-10.mga6
+ Revision: 952615
- Mageia 6 Mass Rebuild

* Thu Apr 30 2015 luigiwalser <luigiwalser> 1.2.103-9.mga5
+ Revision: 820920
- actually apply CVE-2014-4668 patch
- remove unused patch

* Thu Apr 23 2015 shlomif <shlomif> 1.2.103-7.mga5
+ Revision: 820572
- Fix MGA#15755 / CVE-2014-4668 .

* Fri Nov 14 2014 fwang <fwang> 1.2.103-6.mga5
+ Revision: 797021
- rebuild for new ffmpeg

* Wed Oct 15 2014 umeabot <umeabot> 1.2.103-5.mga5
+ Revision: 745905
- Second Mageia 5 Mass Rebuild

* Thu Sep 18 2014 umeabot <umeabot> 1.2.103-4.mga5
+ Revision: 693593
- Rebuild to fix library dependencies

* Tue Sep 16 2014 umeabot <umeabot> 1.2.103-3.mga5
+ Revision: 678371
- Mageia 5 Mass Rebuild
+ tv <tv>
- s/uggests:/Recommends:/

* Sat Oct 19 2013 umeabot <umeabot> 1.2.103-2.mga4
+ Revision: 529987
- Mageia 4 Mass Rebuild

* Mon Jul 15 2013 fwang <fwang> 1.2.103-1.mga4
+ Revision: 454588
- add ctk source
- br wget
- fix non-exist dir
- use autogen
- new version 1.2.103

* Fri Jan 11 2013 umeabot <umeabot> 1.2.101-10.mga3
+ Revision: 347671
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Dec 01 2012 fwang <fwang> 1.2.101-9.mga3
+ Revision: 323636
- rebuild for new pcre

* Mon Jun 04 2012 fwang <fwang> 1.2.101-8.mga3
+ Revision: 253897
- fix build with latest ffmpeg
- rebuild for new ffmpeg

* Sat Apr 28 2012 tmb <tmb> 1.2.101-7.mga2
+ Revision: 233621
- Require rpm-helper >= 0.24.8-1 for systemd support

* Fri Apr 27 2012 tmb <tmb> 1.2.101-6.mga2
+ Revision: 233523
- rebuild for versioned rpm-helper requires

* Mon Apr 23 2012 fwang <fwang> 1.2.101-5.mga2
+ Revision: 232830
- fix compat init file

* Mon Apr 23 2012 fwang <fwang> 1.2.101-4.mga2
+ Revision: 232802
- suggest rrdtool for graphical statistics

* Mon Apr 23 2012 fwang <fwang> 1.2.101-3.mga2
+ Revision: 232798
- fix wrong tag

* Mon Apr 23 2012 fwang <fwang> 1.2.101-2.mga2
+ Revision: 232794
- fix wrong tag
- add systemd unit

* Sun Dec 11 2011 fwang <fwang> 1.2.101-1.mga2
+ Revision: 180700
- fix linkage
- new version 1.2.101

* Mon Sep 12 2011 fwang <fwang> 1.2.99-1.mga2
+ Revision: 142574
- new version 1.2.99

* Fri Jun 24 2011 fwang <fwang> 1.2.98-1.mga2
+ Revision: 112950
- new version 1.2.98

* Fri Mar 25 2011 dmorgan <dmorgan> 1.0.19-2.mga1
+ Revision: 77245
- Rebuild against new mysql

* Tue Feb 01 2011 dmorgan <dmorgan> 1.0.19-1.mga1
+ Revision: 46098
- Remove mdv macros
- imported package cherokee


* Mon Jan 31 2011 Lonyai Gergely <aleph@mandriva.org> 1.0.19-1mdv2011.0
+ Revision: 634579
- 1.0.19

* Thu Jan 20 2011 Lonyai Gergely <aleph@mandriva.org> 1.0.18-1
+ Revision: 631868
- 1.0.18

* Wed Jan 12 2011 Lonyai Gergely <aleph@mandriva.org> 1.0.16-1
+ Revision: 630959
- 1.0.16

* Sat Jan 01 2011 Oden Eriksson <oeriksson@mandriva.com> 1.0.15-4mdv2011.0
+ Revision: 627216
- rebuilt against mysql-5.5.8 libs, again

* Thu Dec 30 2010 Oden Eriksson <oeriksson@mandriva.com> 1.0.15-3mdv2011.0
+ Revision: 626510
- rebuilt against mysql-5.5.8 libs

* Thu Dec 30 2010 Funda Wang <fwang@mandriva.org> 1.0.15-1mdv2011.0
+ Revision: 626270
- new version 1.0.15

* Tue Dec 14 2010 Funda Wang <fwang@mandriva.org> 1.0.14-1mdv2011.0
+ Revision: 621747
- update file list
- new version 1.0.14

* Fri Dec 10 2010 Lonyai Gergely <aleph@mandriva.org> 1.0.13-1mdv2011.0
+ Revision: 620436
- 1.0.13

* Wed Dec 01 2010 Lonyai Gergely <aleph@mandriva.org> 1.0.12-1mdv2011.0
+ Revision: 604627
- 1.0.12

* Thu Nov 25 2010 Lonyai Gergely <aleph@mandriva.org> 1.0.10-1mdv2011.0
+ Revision: 601168
- New file: CTK-run
- 1.0.10

* Thu Nov 11 2010 Lonyai Gergely <aleph@mandriva.org> 1.0.9-2mdv2011.0
+ Revision: 595948
- Provide libcherokee-config
- Drop package: libcherokee-config
- 1.0.9

* Tue Nov 02 2010 Rémy Clouard <shikamaru@mandriva.org> 1.0.8-2mdv2011.0
+ Revision: 592563
- make cherokee provide webserver

* Thu Aug 12 2010 Lonyai Gergely <aleph@mandriva.org> 1.0.8-1mdv2011.0
+ Revision: 569211
- 1.0.8

* Mon Aug 09 2010 Funda Wang <fwang@mandriva.org> 1.0.7-1mdv2011.0
+ Revision: 568058
- new version 1.0.7

* Wed Aug 04 2010 Lonyai Gergely <aleph@mandriva.org> 1.0.6-1mdv2011.0
+ Revision: 565879
- 1.0.6

* Wed Jul 07 2010 Lonyai Gergely <aleph@mandriva.org> 1.0.5-1mdv2011.0
+ Revision: 549843
- 1.0.5
- 1.0.4
- 1.0.2
- 1.0.1

* Tue May 18 2010 Funda Wang <fwang@mandriva.org> 1.0.0-1mdv2010.1
+ Revision: 545086
- New version 1.0.0 stable

  + Lonyai Gergely <aleph@mandriva.org>
    - 0.99.48

* Tue May 04 2010 Funda Wang <fwang@mandriva.org> 0.99.45-2mdv2010.1
+ Revision: 541909
- sync with fedora initfile (suppress confusing output)

* Mon Apr 26 2010 Funda Wang <fwang@mandriva.org> 0.99.45-1mdv2010.1
+ Revision: 538916
- update to new version 0.99.45

* Tue Apr 13 2010 Funda Wang <fwang@mandriva.org> 0.99.44-2mdv2010.1
+ Revision: 534175
- rebuild

* Sun Mar 28 2010 Sandro Cazzaniga <kharec@mandriva.org> 0.99.44-1mdv2010.1
+ Revision: 528476
- update to 0.99.44

* Thu Feb 18 2010 Oden Eriksson <oeriksson@mandriva.com> 0.99.43-2mdv2010.1
+ Revision: 507479
- rebuild

* Thu Feb 18 2010 Funda Wang <fwang@mandriva.org> 0.99.43-1mdv2010.1
+ Revision: 507368
- update to new version 0.99.43

* Thu Jan 28 2010 Frederik Himpe <fhimpe@mandriva.org> 0.99.42-1mdv2010.1
+ Revision: 497853
- update to new version 0.99.42

* Wed Jan 27 2010 Funda Wang <fwang@mandriva.org> 0.99.41-1mdv2010.1
+ Revision: 497174
- new version 0.99.41

* Tue Dec 29 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.39-1mdv2010.1
+ Revision: 483297
- Update to new version 0.99.39

* Thu Dec 24 2009 Funda Wang <fwang@mandriva.org> 0.99.38-1mdv2010.1
+ Revision: 482038
- new version 0.99.38

* Thu Dec 17 2009 Funda Wang <fwang@mandriva.org> 0.99.37-1mdv2010.1
+ Revision: 479620
- new verison 0.99.37

* Sun Dec 13 2009 Funda Wang <fwang@mandriva.org> 0.99.35-1mdv2010.1
+ Revision: 478132
- new version 0.99.35

* Sat Dec 12 2009 Funda Wang <fwang@mandriva.org> 0.99.34-1mdv2010.1
+ Revision: 477741
- new version 0.99.34

* Thu Dec 10 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.32-1mdv2010.1
+ Revision: 476113
- update to new version 0.99.32

* Thu Dec 03 2009 Funda Wang <fwang@mandriva.org> 0.99.31-1mdv2010.1
+ Revision: 472870
- new version 0.99.31

* Mon Nov 30 2009 Funda Wang <fwang@mandriva.org> 0.99.30-1mdv2010.1
+ Revision: 471782
- new version 0.99.30
- add ifarg

* Sun Nov 29 2009 Funda Wang <fwang@mandriva.org> 0.99.29-2mdv2010.1
+ Revision: 471453
- fcgi has been merged in cgi since php 5.3.1 (>= 2010)
- use fastcgi support

* Fri Nov 20 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.29-1mdv2010.1
+ Revision: 467674
- update to new version 0.99.29

* Tue Nov 17 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.28-1mdv2010.1
+ Revision: 467024
- update to new version 0.99.28

* Fri Nov 06 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.27-1mdv2010.1
+ Revision: 462038
- update to new version 0.99.27

* Tue Sep 01 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.24-1mdv2010.0
+ Revision: 423675
- update to new version 0.99.24

* Wed Aug 05 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.22-1mdv2010.0
+ Revision: 410298
- update to new version 0.99.22

* Wed Jul 01 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.20-1mdv2010.0
+ Revision: 391357
- update to new version 0.99.20

* Thu Jun 25 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.19-1mdv2010.0
+ Revision: 389196
- update to new version 0.99.19

* Mon Jun 22 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.18-1mdv2010.0
+ Revision: 388053
- update to new version 0.99.18

* Sun Jun 14 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.17-1mdv2010.0
+ Revision: 385846
- update to new version 0.99.17

* Wed Jun 10 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.16-1mdv2010.0
+ Revision: 384902
- update to new version 0.99.16

* Wed May 13 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.15-1mdv2010.0
+ Revision: 375515
- Update to new version 0.99.15

* Wed May 06 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.14-1mdv2010.0
+ Revision: 372658
- Update to new version 0.99.14
- Fix source URL

* Fri May 01 2009 Funda Wang <fwang@mandriva.org> 0.99.13-1mdv2010.0
+ Revision: 369395
- New version 0.99.13

* Fri May 01 2009 Funda Wang <fwang@mandriva.org> 0.99.11-1mdv2010.0
+ Revision: 369353
- New version 0.99.11

* Mon Mar 30 2009 Funda Wang <fwang@mandriva.org> 0.99.4-2mdv2009.1
+ Revision: 362425
- fix initscript typo

* Fri Mar 13 2009 Frederik Himpe <fhimpe@mandriva.org> 0.99.4-1mdv2009.1
+ Revision: 354689
- Update to new version 0.99.4
- Use %%serverbuild macro

* Tue Jan 27 2009 Funda Wang <fwang@mandriva.org> 0.98.1-1mdv2009.1
+ Revision: 334167
- new version 0.98.1

* Sat Jan 24 2009 Funda Wang <fwang@mandriva.org> 0.98.0-1mdv2009.1
+ Revision: 333183
- 0.98.0
- New version 0.11.5
- there is no server subpackage
- add init and logrotate
- add manpages
- add cget
- import cherokee


